#include <windows.h>
#include <stdlib.h>
#include <wtypes.h>
#include <conio.h>
#include <stdio.h>
#include "main.h"


BOOLEAN LoadLibraries()
{
	hLib30x = LoadLibrary ("LL_USB.dll");
    if(!hLib30x) return FALSE;
    return TRUE;
}

BOOLEAN InitLibFuncs()
{  
	EX_Connect = (P_DLL_EX_CONNECT)GetProcAddress(hLib30x, "EX_Connect");
	if(!EX_Connect) return FALSE;
	EX_SetScanType =  (P_DLL_EX_SET_SCAN_TYPE)GetProcAddress(hLib30x, "EX_SetScanType");
	if(!EX_SetScanType) return FALSE;
	EX_SetMultiChanScanChans =  (P_DLL_EX_SET_MULTI_CHAN_SCAN_CHANS)GetProcAddress(hLib30x, "EX_SetMultiChanScanChans");
	if(!EX_SetMultiChanScanChans) return FALSE;
	EX_SetDataLogOptions =  (P_DLL_EX_SET_DATA_LOG_OPTIONS)GetProcAddress(hLib30x, "EX_SetDataLogOptions");
	if(!EX_SetDataLogOptions) return FALSE;
	EX_Run =  (P_DLL_EX_RUN)GetProcAddress(hLib30x, "EX_Run");
	if(!EX_Run) return FALSE;
	EX_CheckScanStatus = (P_DLL_EX_CHECK_SCAN_STATUS)GetProcAddress(hLib30x, "EX_CheckScanStatus");
	if(!EX_CheckScanStatus) return FALSE;
	EX_GetScanDataDbl =  (P_DLL_EX_GET_SCAN_DATA_DOUBLE)GetProcAddress(hLib30x, "EX_GetScanDataDbl");
	if(!EX_GetScanDataDbl) return FALSE;
	EX_Stop =  (P_DLL_EX_STOP)GetProcAddress(hLib30x, "EX_Stop");
	if(!EX_Stop) return FALSE;
	EX_StopComplete =  (P_DLL_EX_STOP_COMPLETE)GetProcAddress(hLib30x, "EX_StopComplete");
	if(!EX_StopComplete) return FALSE;

    return TRUE;
}

// Developer NOTE:
// My IDE is set to use "__stdcall" calling convention, so the following "__cdecl" casting of main is required
int __cdecl main()
{
	USHORT usDevID = 0;
	BOOLEAN fRetVal = FALSE; BOOLEAN fRedraw = FALSE;

	if(!LoadLibraries()){ printf("Failed to load libraries"); getch(); return 0;}
	printf("Success loading libraries\n");

	if(!InitLibFuncs())
	{ printf("Failed to find required functions"); getch(); return 0;}

	printf("Success finding required functions\nConnecting -  please wait. . .");
	fRetVal = EX_Connect(&usDevID);
	if(!(fRetVal | usDevID))
	{ printf("Failed  EX_Connect()"); getch(); return 0; }
	SetCon(); // just sets up the console display

	char cUserInputVal = NULL; 
	int iKeyChar = 0;
	//char szOutVal[32], szTempBuff[32]; int iKeyChar = 0;
	BOOLEAN fScanStartSuccess = TRUE; BOOLEAN fRunning = FALSE;

	while(true)
	{
		setMainScreen();
		fRedraw = FALSE;

		while((cUserInputVal != 'Q') && (cUserInputVal != 'q') && (cUserInputVal != 27) && (!fRedraw))
		{
			cUserInputVal = (char)getch();
			switch(cUserInputVal)
			{
				case 'Q': case 'q': case 27:
					printf("\nDisconnecting and exiting, please wait ....\n"); break;
				case 'R': case 'r':
					fRedraw = TRUE; system("cls"); break;
				case 'S': case 's':
					
					fScanStartSuccess = TRUE;
					ConsoleCursorInfo.bVisible = FALSE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);

					while(true)
					{
						if(!EX_SetScanType (usDevID, MULTI_CHAN_SCAN)) { fScanStartSuccess = FALSE; break; }
						if(!EX_SetMultiChanScanChans (usDevID, 2)) { fScanStartSuccess = FALSE; break; }
						if(!EX_SetDataLogOptions (usDevID, SCAN_USE_DATA_ARRAY, 0, 0)) { fScanStartSuccess = FALSE; break; }
						if(!EX_Run (usDevID)) { fScanStartSuccess = FALSE; break; }

						printf("\nScan running. Press 'E' to end run\n"); fRunning = TRUE; 
						// DEVELOPER NOTE:
						// The following loop is used to simplify the code. There are other things that can be done
						//  during a scan, for example - send digital output or read digital input, change the channel
						//  when in single-channel scan mode, send an analog output, etc.
						while(fRunning)
						{
							EX_CheckScanStatus(usDevID, &puiNumScansRemainingInBuff, &pfStillScanning, &puiStatusCode);
							gotoxy(0,12); printf("scans in buff: % 3u, code: 0x%03X, StillScanning: %s", puiNumScansRemainingInBuff, puiStatusCode, pfStillScanning > 0 ? "YES" : " NO");

							if(puiNumScansRemainingInBuff > 0)
							{
								// DEVELOPER NOTE:
								// The following will only display the first of however many scans are 
								// now ready. You will probably want to display all of the scan data
								uiNumScansToReturn = puiNumScansRemainingInBuff <= (sizeof(pdblDataBuff) / 2) ? puiNumScansRemainingInBuff : puiTotalBuffSize / 2;
								EX_GetScanDataDbl (usDevID, pdblDataBuff, uiNumScansToReturn / 2, FALSE, &puiNumScansReturned, 
									&puiNumScansRemainingInBuff, &pfStillScanning, &puiTotalBuffSize, &puiStatusCode); 
								gotoxy(0,13); printf("chan 0: % 2.5lf", dblDataBuff[0]);
								gotoxy(0,14); printf("chan 1: % 2.5lf", dblDataBuff[1]);

							}

							if(_kbhit())
							{
								iKeyChar = getch();
								cUserInputVal = (char)iKeyChar;
								if((cUserInputVal == 27) || (cUserInputVal == 'E') || (cUserInputVal == 'e'))
								{
									gotoxy(0,17); printf("Completing scan stop - wait....");
									gotoxy(0,18); 
									if(!EX_Stop(usDevID)) printf("failed to stop scan run\n"); 
									else
									{ EX_StopComplete(usDevID); printf("\nScan Stopped.\n"); fRunning = FALSE; }
									cUserInputVal=0; break;
								}
								else
								{ gotoxy(0,15); printf("\ngot key: %c\n", (char)iKeyChar); }
							}
						}
						if(!fScanStartSuccess)
						{
							printf("\nScan failed to start. Any key to continue\n");
							getch();
						}
						setMainScreen(); 
						ConsoleCursorInfo.bVisible = TRUE; SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
						break;
					}
			}
		}
		if(!fRedraw) break;
	}

	return 1;
}

void setMainScreen(void)
{
	system("cls");
		printf("\nINITIALIZED\nPress one of the following keys:\n"
			"'Q' quit\n"
			"'R' redraw screen\n"
			"'S' start scanning\n"
			"'E' end scanning\n"
			);
}

BOOLEAN SetCon(void)
{
	hOutCon = GetStdHandle(STD_OUTPUT_HANDLE);
	if(!hOutCon)
	{
		MessageBox(0, "Error writing to console", "-- error", MB_OK);
		return FALSE;
	}
	hInCon =  GetStdHandle(STD_INPUT_HANDLE);
	if(!hInCon)
	{
		MessageBox(0, "Error reading from console", "-- error", MB_OK);
		return FALSE;
	}

	ConsoleCursorInfo.dwSize=1;
	ConsoleCursorInfo.bVisible = TRUE;
	SetConsoleCursorInfo(hOutCon, &ConsoleCursorInfo);
	return TRUE;
}